# toc_run_description = looking for libdl
# toc_begin_help =
#
# Looks for libdl. It calls toc_export
# for the following variables:
#
#	HAVE_LIBDL = 0 or 1
#	LDADD_LIBDL = empty or "-ldl -export-dynamic"
#	LDADD_DL = empty or "-ldl -export-dynamic", possibly with -L/path...
#
# Note that LDADD_LIBDL is specific to the libdl test, whereas LDADD_DL is used
# by both the libdl and libltdl tests.
#
# = toc_end_help

toc_add_config HAVE_LIBDL=0
toc_add_config LDADD_LIBDL=
toc_export LDADD_DL=

err=1

toc_test gcc_build_and_run ${TOC_HOME}/tests/c/check_for_dlopen_and_friends.c -export-dynamic -ldl && {
    err=0
    toc_export HAVE_LIBDL=1
    toc_export LDADD_LIBDL="-ldl -export-dynamic"
    toc_export LDADD_DL="${LDADD_LIBDL}"
}

return $err



